<template>
  <BaseCard
    :title="dataset.title"
    :external-link="getExternalLink"
    :main-user="mainUser"
    :date="mainVersion.date"
    class="card-prj"
  >
    <template #header>
      <h3 class="card-title"></h3>
      <div class="ribbon ribbon-top ribbon-left ribbon-bookmark bg-gray-lt">
        <a data-toggle="tooltip" data-placement="bottom"
          ><span class="badge badge-pill bg-purple-lt">1</span></a
        >
      </div>
      <div class="card-options">
        <b-col cols="auto" class="px-0 mr-1">
          <b-button
            v-b-modal.modal-import-into-project
            data-cy="import-dataset-btn"
            variant="datasets"
            size="sm"
            @click="importIntoProject"
          >
            <FolderPlusIcon class="icon-xxs" />
            Import
          </b-button>
        </b-col>
        <b-dropdown
          variant="link"
          toggle-tag="a"
          toggle-class="p-0 card-dropdown dropdown-job-actions"
          no-caret
          right
        >
          <template #button-content>
            <DotsVerticalIcon />
          </template>
          <b-dropdown-item
            link-class="pt-1 pb-1"
            :disabled="!hasFiles"
            :href="downloadLink"
            target="_blank"
          >
            <DownloadIcon class="dropdown-item-icon" />
            Download
          </b-dropdown-item>
          <b-dropdown-item :href="mailTo" link-class="pt-1 pb-1">
            <QuestionMarkIcon class="dropdown-item-icon" />
            Ask for support
          </b-dropdown-item>
        </b-dropdown>
      </div>
    </template>
    <template #subtitle>
      <ul
        class="nav mx-auto"
        data-toggle="tabs"
        @click="() => (showVersions = !showVersions)"
        @focusout="() => (showVersions = false)"
      >
        <li class="dropdown dropdown-tab">
          <a
            href="#"
            class="btn btn-sm dropdown-toggle"
            data-toggle="dropdown"
            data-target="#ipc-analysis-versions-menu"
          >
            <VersionsIcon
              v-if="versions.length > 1"
              size="24"
              class="icon-xxs"
            />
            <RectangleVerticalIcon v-else class="icon-xxs" />
            <span class="text-version">{{ versions[0].number }}</span>
          </a>
          <ul
            id="ipc-analysis-versions-menu"
            class="nav nav-tabs dropdown-menu dropdown-menu-center mw-0"
            :class="showVersions ? 'show' : ''"
          >
            <li v-for="version in versions" :key="version.index">
              <a
                id="ipc-analysis-3-1-0-tab"
                class="mw-0 btn-xs dropdown-item active disabled"
                href="#tabs-ipc-analysis-3-1-0"
              >
                <span
                  title="alive"
                  class="badge bg-alive mr-auto ml-1 mr-1"
                ></span>
                <span class="text-version ml-3 mr-3">{{ version.number }}</span>
                <span
                  v-if="version.label"
                  :title="version.label"
                  class="badge badge-small-text bg-purple-lt ml-auto"
                  >{{ version.label }}</span
                >
              </a>
            </li>
          </ul>
        </li>
      </ul>
    </template>
    <template #body-bottom>
      <div>
        <div class="avatar-list avatar-list-stacked">
          <Avatar
            v-b-tooltip.hover.right="{ variant: 'dark' }"
            img="/avatars/001s.png"
            title="patstat-3D.sqlite<br/>538.411 MB"
            badge="bg-online"
          />
        </div>
      </div>
    </template>
    <template #description>
      <div class="mt-3 mb-2 text-justify">
        <div class="markdown lh-base small text-clamp-2 mb-0">
          {{ dataset.short_description }}
        </div>
        <a
          v-if="dataset.short_description.length > 60"
          v-b-tooltip.hover.top="{ variant: 'dark' }"
          :title="dataset.short_description"
          class="d-flex h6 cursor-default"
          >Learn more...</a
        >
      </div>
    </template>
    <template #badges>
      <div class="lh-sm w-100 cursor-not-allowed">
        <a class="disabled-action">
          <b-badge class="badge-small-text text-uppercase bg-indigo-lt w-100">
            <TagIcon class="icon-xxs" />
          </b-badge>
        </a>
      </div>
      &nbsp;
      <div class="lh-sm w-100">
        <a class="disabled-action">
          <b-badge class="badge-small-text text-uppercase bg-blue-lt w-100">
            <DatabaseIcon class="icon-xxs" /> {{ dataset.title }}
          </b-badge>
        </a>
      </div>
    </template>
    <template #progress>
      <b-progress class="card-progress">
        <b-progress-bar class="w-0"></b-progress-bar>
      </b-progress>
    </template>
  </BaseCard>
</template>

<script>
export default {
  props: {
    dataset: {
      type: Object,
      default() {
        return {
          fullName: '',
          firstName: '',
        };
      },
    },
    date: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      showVersions: false,
    };
  },
  computed: {
    mailTo() {
      return `mailto:${this.$nuxt.context.store.getters['ui/mailTo']}`;
    },
    versionString() {
      return Object.keys(this.dataset.versions)[0];
    },
    mainVersion() {
      return this.dataset.versions[this.versionString];
    },
    mainUser() {
      return {
        firstName: this.mainVersion.authors_ids[0],
      };
    },
    hasFiles() {
      return Object.keys(this.mainVersion.files).length;
    },
    versions() {
      return Object.keys(this.dataset.versions).map((versionString) => {
        return {
          ...this.dataset.versions[versionString],
          number: versionString,
        };
      });
    },
    downloadLink() {
      const encodedId = encodeURIComponent(this.dataset.id);
      let token = this.$auth.strategy.token.get().split(' ');
      token = token[1];
      return `${this.$config.apiRoot}/datasets/${encodedId}/files?access_token=${token}`;
    },
    getExternalLink() {
      return `${this.$config.datastoreUrl}/loginpage.xhtml?redirectPage=/dataset.xhtml?persistentId=${this.dataset.id}&silentAutoLogin=true`;
    },
  },
  methods: {
    importIntoProject() {
      this.$nuxt.context.store.commit('ui/setImportObject', {
        type: 'dataset',
        object: this.dataset,
      });
    },
  },
};
</script>
